;
; hd.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; hd [file]
;;
;;   Prints hexadecimal dump of file
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= 0

offset		= $fb

banner		= "hexdump 0.2 by soci/singular"

		.include "lib.asm"

		.section code
start2		ldx #<arglist
		ldy #>arglist
		jsr parseargs

		lda arglist
		ldx #<(arglist+1)
		ldy #>(arglist+1)
		jsr $ffbd
		lda #1
		ldx mydrive
		ldy #0
		sty offset
		sty offset+1
		sty offset+2
		jsr $ffba
		jsr $ffc0
		bcs +
		jsr loop
		lda #1
		jsr $ffc3
+		jmp exit

err		rts

loop		ldx #1
		jsr $ffc6
		bcs err

		ldx #0
-		jsr $ffcf
		ldy $90
		beq +
		cpy #$40
		bne mk
+		sta buffer,x
		inx
		bcs mk
		cpx #8
		blt -

mk		txa
		beq fin
		stx buffl
		sty eof

		ldx #3
		jsr $ffc9
		bcs err

		ldx #2
-		lda offset,x
		jsr printhex
		dex
		bpl -

		ldy #0
-		lda #" "
		jsr $ffd2
		cpy buffl
		blt +
		jsr $ffd2
		jsr $ffd2
		gcc e
+		lda buffer,y
		jsr printhex
e		iny
		cpy #8
		blt -

		ldy #0
		lda #" "
		jsr $ffd2
-		lda #1
		sta $d4
		lda buffer,y
		cmp #"{cr}"
		beq d
		cmp #"{shift return}"
		bne +
d		lda #" "
+		jsr $ffd2
		iny
		cpy buffl
		blt -
		lsr $d4
		lda #"{cr}"
		jsr $ffd2
		lda $90
		bne fin
		lda $91
		cmp #$7f
		beq fin

		lda offset
		clc
		adc #8
		sta offset
		bcc +
		inc offset+1
		bne +
		inc offset+2
+
		lda eof
		beq loop

fin		jmp $ffcc
		.send code

		.section bss
buffer		.fill 8
buffl		.byte ?
eof		.byte ?
		.send bss
